[Ironpython-users] Passing Python exceptions in a sandboxed domain

Dino Viehland dinov at microsoft.com
Wed Mar 21 23:58:23 CET 2012

The Execute methods have ExecuteAndWrap versions which catch the exception locally and return it as an ObjectHandle.  You can then pass that object handle back into either ObjectOperations or ExceptionOperations to do the formatting or conversion into a string in the remote domain.

If you need code that's more like what you specifically have below (because you're not just executing code) you can always do the same trick - in the remote app domain catch the exception, and then pass out a new ObjectHandle to the exception object rather than passing the object back.

From: ironpython-users-bounces+dinov=exchange.microsoft.com at python.org [mailto:ironpython-users-bounces+dinov=exchange.microsoft.com at python.org] On Behalf Of Cesar Mello
Sent: Wednesday, March 21, 2012 2:16 PM
To: ironpython-users at python.org
Subject: Re: [Ironpython-users] Passing Python exceptions in a sandboxed domain

Hey guys,

I know this is not IronPython specific, but it is causing pain to embbed IronPython in our product. If someone can help, thanks so much!

I can repro the problem throwing a TypeErrorException from the restricted appdomain like this:

        // starts with standard Internet Zone sandbox permissions
        var evidence = new Evidence();
        evidence.AddHostEvidence(new Zone(SecurityZone.Internet));
        var permissionSet = SecurityManager.GetStandardSandbox(evidence);
        permissionSet.AddPermission(new ReflectionPermission(PermissionState.Unrestricted));

        var setup = new AppDomainSetup();
        setup.ApplicationBase = AppDomain.CurrentDomain.BaseDirectory;
        setup.ApplicationName = "ConsoleScriptHost";

        var domain = AppDomain.CreateDomain(setup.ApplicationName, evidence, setup, permissionSet, null);

            var x = new IronPython.Runtime.Exceptions.TypeErrorException("xxx");
            throw x;
        catch (SecurityException ex)
          var m = ex.Message; // why this?

On Mon, Mar 19, 2012 at 10:50 AM, Cesar Mello <cmello at gmail.com<mailto:cmello at gmail.com>> wrote:

When I try to run something like 'None + 2' inside a sandboxed domain, I'm getting the following exception:

Message: Request failed

Stack trace:

 at IronPython.Runtime.Exceptions.TypeErrorException.GetObjectData(SerializationInfo info, StreamingContext context)
   at System.Runtime.Serialization.ObjectCloneHelper.GetObjectData(Object serObj, String& typeName, String& assemName, String[]& fieldNames, Object[]& fieldValues)

Any help is greatly appreciated.

To help debugging, I thought about adding a command line argument to ipy console for setting up a standard Internet-zone sandbox.

Thank you!

Best regards

-------------- next part --------------
An HTML attachment was scrubbed...
URL: <http://mail.python.org/pipermail/ironpython-users/attachments/20120321/d201b8b1/attachment.html>

More information about the Ironpython-users mailing list